from typing import ClassVar, Optional

from typing import overload

class Config:
    configVersion: ConfigVersion
    model: Model
    @overload
    def __init__(self) -> None: ...
    @overload
    def __init__(self, configVersion: ConfigVersion, model: Model) -> None: ...

class ConfigVersion:
    __members__: ClassVar[dict] = ...  # read-only
    THE_10: ClassVar[ConfigVersion] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class DataType:
    __members__: ClassVar[dict] = ...  # read-only
    FLOAT16: ClassVar[DataType] = ...
    FLOAT32: ClassVar[DataType] = ...
    INT8: ClassVar[DataType] = ...
    UINT8: ClassVar[DataType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Head:
    metadata: Metadata
    outputs: Optional[list[str]]
    parser: str
    def __init__(self) -> None: ...

class Input:
    dtype: DataType
    inputType: InputType
    layout: Optional[str]
    name: str
    preprocessing: PreprocessingBlock
    shape: list[int]
    def __init__(self) -> None: ...

class InputType:
    __members__: ClassVar[dict] = ...  # read-only
    IMAGE: ClassVar[InputType] = ...
    RAW: ClassVar[InputType] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Metadata:
    anchors: Optional[list[list[list[float]]]]
    anglesOutputs: Optional[list[str]]
    boxesOutputs: Optional[str]
    classes: Optional[list[str]]
    confThreshold: Optional[float]
    extraParams: json
    iouThreshold: Optional[float]
    isSoftmax: Optional[bool]
    keypointsOutputs: Optional[list[str]]
    maskOutputs: Optional[list[str]]
    maxDet: Optional[int]
    nClasses: Optional[int]
    nKeypoints: Optional[int]
    nPrototypes: Optional[int]
    postprocessorPath: Optional[str]
    protosOutputs: Optional[str]
    scoresOutputs: Optional[str]
    subtype: Optional[ObjectDetectionSubtypeYolo]
    yoloOutputs: Optional[list[str]]
    def __init__(self) -> None: ...

class MetadataClass:
    name: str
    path: str
    precision: Optional[DataType]
    def __init__(self) -> None: ...

class Model:
    heads: Optional[list[Head]]
    inputs: list[Input]
    metadata: MetadataClass
    outputs: list[Output]
    def __init__(self) -> None: ...

class ObjectDetectionSubtypeYolo:
    __members__: ClassVar[dict] = ...  # read-only
    YOLOV10: ClassVar[ObjectDetectionSubtypeYolo] = ...
    YOLOV5: ClassVar[ObjectDetectionSubtypeYolo] = ...
    YOLOV6: ClassVar[ObjectDetectionSubtypeYolo] = ...
    YOLOV6_R2: ClassVar[ObjectDetectionSubtypeYolo] = ...
    YOLOV7: ClassVar[ObjectDetectionSubtypeYolo] = ...
    YOLOV8: ClassVar[ObjectDetectionSubtypeYolo] = ...
    __entries: ClassVar[dict] = ...
    def __init__(self, value: int) -> None: ...
    def __eq__(self, other: object) -> bool: ...
    def __getstate__(self) -> int: ...
    def __hash__(self) -> int: ...
    def __index__(self) -> int: ...
    def __int__(self) -> int: ...
    def __ne__(self, other: object) -> bool: ...
    def __setstate__(self, state: int) -> None: ...
    @property
    def name(self) -> str: ...
    @property
    def value(self) -> int: ...

class Output:
    dtype: DataType
    name: str
    def __init__(self) -> None: ...

class PreprocessingBlock:
    interleavedToPlanar: Optional[bool]
    mean: Optional[list[float]]
    reverseChannels: Optional[bool]
    scale: Optional[list[float]]
    def __init__(self) -> None: ...
